/* filelib.c - jonclegg@yahoo.com
 * library routines for file operations
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "compat.h"
#include "filelib.h"
#include "util.h"
#include "debug.h"
#include <assert.h>

#define TEMP_STR_LEN	(MAX_FILENAME*2)

/*********************************************************************************
 * Public functions
 *********************************************************************************/
error_code	filelib_init(BOOL do_count, BOOL keep_incomplete);
error_code	filelib_start(char *filename);
error_code	filelib_end(char *filename, BOOL over_write_existing, /*out*/ char *fullpath);
error_code	filelib_write(char *buf, u_long size);
error_code	filelib_set_output_directory(char *str);
void				filelib_shutdown();
error_code  filelib_remove(char *filename);


/*********************************************************************************
 * Private Functions
 *********************************************************************************/
static error_code	mkdir_if_needed(char *str);
static void			close_file();
static BOOL			file_exists(char *filename);
static void trim_filename(char *filename, char* out);


/*********************************************************************************
 * Private Vars
 *********************************************************************************/
static FHANDLE 	m_file;
static int 	m_count;
static char 	m_output_directory[MAX_PATH];
static char 	m_incomplete_directory[MAX_PATH];
static char 	m_filename_format[] = "%s%s.mp3";
static BOOL	m_keep_incomplete = TRUE;


// For now we're not going to care. If it makes it good. it not, will know 
// When we try to create a file in the path.
error_code mkdir_if_needed(char *str)
{
	return SR_SUCCESS;

}

error_code filelib_init(BOOL do_count, BOOL keep_incomplete)
{

	return SR_SUCCESS;
}


error_code filelib_set_output_directory(char *str)
{
	return SR_SUCCESS;
}

void close_file()
{
}

BOOL file_exists(char *filename)
{
	return TRUE;
}

error_code filelib_start(char *filename)
{
	return SR_SUCCESS;
}

// Moves the file from incomplete to output directory
// Needs to be tested, added ok_to_write = FALSE, before it wasn't even
// initilzed. 
// *** fullpath must be over MAX_FILENAME len
error_code filelib_end(char *filename, BOOL over_write_existing, /*out*/ char *fullpath)
{
	return SR_SUCCESS;
}



void filelib_shutdown()
{
	close_file();

	/* 
    	 * We're just calling this to zero out 
	 * the vars, it's not really nessasary.
	 */
	filelib_init(FALSE, TRUE);
}

error_code filelib_remove(char *filename)
{
	return SR_SUCCESS;
}

void trim_filename(char *filename, char* out)
{
	long maxlen = MAX_PATH_LEN-strlen(m_incomplete_directory);
	
	strncpy(out, filename, MAX_TRACK_LEN);
	strip_invalid_chars(out);
	out[maxlen-4] = '\0';	// -4 for ".mp3"
}
